/*
 * bklines.c - print lines in a file backwards
 *
 * An N-line file is printed as lines N, N-1, N-2, ... 1
 *
 * 7/2/90 - D. Methvin
 */

#include <stdio.h>
#include <io.h>
#include <fcntl.h>

#define FBUFSIZE 1024

char	buf[2*FBUFSIZE];

main(int argc, char **argv)
{
	int	fd, fsize, fpos, blen, lnlen;
	char *me = *argv++;
	char	*p;

	if ( --argc <= 0 )
		{
		printf("usage: %s  file\n", me);
		exit(1);
		}
	if ( ( fd = open(*argv, O_RDONLY | O_BINARY)) < 0 )
		{
		fprintf(stderr, "%s: can't open file %s\n", me, *argv);
		exit(1);
		}
	fsize = lseek(fd, 0L, 2 /* EOF */);
	buf[FBUFSIZE] = '\0';
	lnlen = 0;

	for ( fpos = fsize - (fsize % FBUFSIZE); fpos >= 0; fpos -= FBUFSIZE )
		{
		lseek(fd, (long)fpos, 0);
		blen = read(fd, buf, FBUFSIZE);
		if ( blen <= 0 )
			{
			fprintf(stderr, "\n%s: Error reading file %s\n", me, *argv);
			exit(1);
			}
		for ( p = &buf[blen-1]; p >= buf; --p )
			{
			if ( *p == '\n' || *p == '\r' )
				{
				write(1, p+1, lnlen);
				lnlen = 0;
				}
			lnlen++;
			}
		memcpy(&buf[FBUFSIZE],&buf[0],lnlen);
		}
	write(1, &buf[FBUFSIZE], lnlen);
	exit(0);
}


